/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   ps_stktools2.c                                     :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: tmaze <tmaze@student.42.fr>                +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2019/02/25 12:44:08 by tmaze             #+#    #+#             */
/*   Updated: 2019/03/06 16:02:44 by tmaze            ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "push_swap.h"

void	ps_initdata(t_psdata *data)
{
	data->a = NULL;
	data->b = NULL;
	data->size_a = 0;
	data->size_b = 0;
	data->op = NULL;
}

int		check_input(char *in, int *ret)
{
	int		i;

	i = 0;
	if (in[i] && ft_issign(in[i]))
		i++;
	while (in[i] && ft_isdigit(in[i]))
		i++;
	if (in[i] == '\0' && ft_hasdigit(in) && ft_atois(in, ret))
		return (1);
	return (0);
}

int		get_params(t_psdata *data, int ac, char **av)
{
	t_stack	*new;
	char	**tab;
	int		nb;
	int		i;
	int		j;

	i = ac;
	nb = 0;
	while (--i > 0 && !(j = 0))
		if ((tab = ft_strsplitwhitespace(av[i])) != NULL)
		{
			while (tab[j])
				j++;
			while (--j >= 0)
				if (check_input(tab[j], &nb) && (new = ps_stknew(nb)) != NULL)
					ps_stkpsh(data, 'a', new);
				else
				{
					ft_putendl_fd("Error", 2);
					ps_stkclean(data);
					return (0);
				}
			ft_del_words_tables(&tab);
		}
	return (1);
}

int		is_op(char *buff)
{
	static char	ops[11][4] = {"sa\0", "sb\0", "ss\0", "pa\0", "pb\0", "ra\0",
								"rb\0", "rr\0", "rra\0", "rrb\0", "rrr\0"};
	size_t		i;

	i = 0;
	while (i < 11 && ft_strcmp(buff, ops[i]) != 0)
		i++;
	return (i < 11);
}
